// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from vrxperience_msgs:msg/MovableTarget.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__BUILDER_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__BUILDER_HPP_

#include "vrxperience_msgs/msg/detail/movable_target__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace vrxperience_msgs
{

namespace msg
{

namespace builder
{

class Init_MovableTarget_visibility
{
public:
  explicit Init_MovableTarget_visibility(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  ::vrxperience_msgs::msg::MovableTarget visibility(::vrxperience_msgs::msg::MovableTarget::_visibility_type arg)
  {
    msg_.visibility = std::move(arg);
    return std::move(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_height
{
public:
  explicit Init_MovableTarget_height(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_visibility height(::vrxperience_msgs::msg::MovableTarget::_height_type arg)
  {
    msg_.height = std::move(arg);
    return Init_MovableTarget_visibility(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_width
{
public:
  explicit Init_MovableTarget_width(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_height width(::vrxperience_msgs::msg::MovableTarget::_width_type arg)
  {
    msg_.width = std::move(arg);
    return Init_MovableTarget_height(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_length
{
public:
  explicit Init_MovableTarget_length(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_width length(::vrxperience_msgs::msg::MovableTarget::_length_type arg)
  {
    msg_.length = std::move(arg);
    return Init_MovableTarget_width(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_relative_accel
{
public:
  explicit Init_MovableTarget_relative_accel(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_length relative_accel(::vrxperience_msgs::msg::MovableTarget::_relative_accel_type arg)
  {
    msg_.relative_accel = std::move(arg);
    return Init_MovableTarget_length(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_absolute_accel
{
public:
  explicit Init_MovableTarget_absolute_accel(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_relative_accel absolute_accel(::vrxperience_msgs::msg::MovableTarget::_absolute_accel_type arg)
  {
    msg_.absolute_accel = std::move(arg);
    return Init_MovableTarget_relative_accel(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_relative_angular_speed
{
public:
  explicit Init_MovableTarget_relative_angular_speed(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_absolute_accel relative_angular_speed(::vrxperience_msgs::msg::MovableTarget::_relative_angular_speed_type arg)
  {
    msg_.relative_angular_speed = std::move(arg);
    return Init_MovableTarget_absolute_accel(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_relative_speed
{
public:
  explicit Init_MovableTarget_relative_speed(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_relative_angular_speed relative_speed(::vrxperience_msgs::msg::MovableTarget::_relative_speed_type arg)
  {
    msg_.relative_speed = std::move(arg);
    return Init_MovableTarget_relative_angular_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_absolute_angular_speed
{
public:
  explicit Init_MovableTarget_absolute_angular_speed(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_relative_speed absolute_angular_speed(::vrxperience_msgs::msg::MovableTarget::_absolute_angular_speed_type arg)
  {
    msg_.absolute_angular_speed = std::move(arg);
    return Init_MovableTarget_relative_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_absolute_speed
{
public:
  explicit Init_MovableTarget_absolute_speed(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_absolute_angular_speed absolute_speed(::vrxperience_msgs::msg::MovableTarget::_absolute_speed_type arg)
  {
    msg_.absolute_speed = std::move(arg);
    return Init_MovableTarget_absolute_angular_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_elevation_in_vehicle
{
public:
  explicit Init_MovableTarget_elevation_in_vehicle(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_absolute_speed elevation_in_vehicle(::vrxperience_msgs::msg::MovableTarget::_elevation_in_vehicle_type arg)
  {
    msg_.elevation_in_vehicle = std::move(arg);
    return Init_MovableTarget_absolute_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_azimuth_in_vehicle
{
public:
  explicit Init_MovableTarget_azimuth_in_vehicle(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_elevation_in_vehicle azimuth_in_vehicle(::vrxperience_msgs::msg::MovableTarget::_azimuth_in_vehicle_type arg)
  {
    msg_.azimuth_in_vehicle = std::move(arg);
    return Init_MovableTarget_elevation_in_vehicle(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_elevation_in_sensor
{
public:
  explicit Init_MovableTarget_elevation_in_sensor(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_azimuth_in_vehicle elevation_in_sensor(::vrxperience_msgs::msg::MovableTarget::_elevation_in_sensor_type arg)
  {
    msg_.elevation_in_sensor = std::move(arg);
    return Init_MovableTarget_azimuth_in_vehicle(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_azimuth_in_sensor
{
public:
  explicit Init_MovableTarget_azimuth_in_sensor(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_elevation_in_sensor azimuth_in_sensor(::vrxperience_msgs::msg::MovableTarget::_azimuth_in_sensor_type arg)
  {
    msg_.azimuth_in_sensor = std::move(arg);
    return Init_MovableTarget_elevation_in_sensor(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_distance_to_collision
{
public:
  explicit Init_MovableTarget_distance_to_collision(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_azimuth_in_sensor distance_to_collision(::vrxperience_msgs::msg::MovableTarget::_distance_to_collision_type arg)
  {
    msg_.distance_to_collision = std::move(arg);
    return Init_MovableTarget_azimuth_in_sensor(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_pose
{
public:
  explicit Init_MovableTarget_pose(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_distance_to_collision pose(::vrxperience_msgs::msg::MovableTarget::_pose_type arg)
  {
    msg_.pose = std::move(arg);
    return Init_MovableTarget_distance_to_collision(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_anchor_point
{
public:
  explicit Init_MovableTarget_anchor_point(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_pose anchor_point(::vrxperience_msgs::msg::MovableTarget::_anchor_point_type arg)
  {
    msg_.anchor_point = std::move(arg);
    return Init_MovableTarget_pose(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_existence_time
{
public:
  explicit Init_MovableTarget_existence_time(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_anchor_point existence_time(::vrxperience_msgs::msg::MovableTarget::_existence_time_type arg)
  {
    msg_.existence_time = std::move(arg);
    return Init_MovableTarget_anchor_point(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_beam_index
{
public:
  explicit Init_MovableTarget_beam_index(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_existence_time beam_index(::vrxperience_msgs::msg::MovableTarget::_beam_index_type arg)
  {
    msg_.beam_index = std::move(arg);
    return Init_MovableTarget_existence_time(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_type
{
public:
  explicit Init_MovableTarget_type(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_beam_index type(::vrxperience_msgs::msg::MovableTarget::_type_type arg)
  {
    msg_.type = std::move(arg);
    return Init_MovableTarget_beam_index(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_detection_status
{
public:
  explicit Init_MovableTarget_detection_status(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_type detection_status(::vrxperience_msgs::msg::MovableTarget::_detection_status_type arg)
  {
    msg_.detection_status = std::move(arg);
    return Init_MovableTarget_type(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_scaner_id
{
public:
  explicit Init_MovableTarget_scaner_id(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_detection_status scaner_id(::vrxperience_msgs::msg::MovableTarget::_scaner_id_type arg)
  {
    msg_.scaner_id = std::move(arg);
    return Init_MovableTarget_detection_status(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_id
{
public:
  explicit Init_MovableTarget_id(::vrxperience_msgs::msg::MovableTarget & msg)
  : msg_(msg)
  {}
  Init_MovableTarget_scaner_id id(::vrxperience_msgs::msg::MovableTarget::_id_type arg)
  {
    msg_.id = std::move(arg);
    return Init_MovableTarget_scaner_id(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

class Init_MovableTarget_header
{
public:
  Init_MovableTarget_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MovableTarget_id header(::vrxperience_msgs::msg::MovableTarget::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_MovableTarget_id(msg_);
  }

private:
  ::vrxperience_msgs::msg::MovableTarget msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::vrxperience_msgs::msg::MovableTarget>()
{
  return vrxperience_msgs::msg::builder::Init_MovableTarget_header();
}

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__BUILDER_HPP_
