// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from vrxperience_msgs:msg/MovableTarget.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__STRUCT_H_
#define VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'DETECTION_STATUS_UNDEFINED'.
enum
{
  vrxperience_msgs__msg__MovableTarget__DETECTION_STATUS_UNDEFINED = 0
};

/// Constant 'DETECTION_STATUS_NEW_TARGET'.
enum
{
  vrxperience_msgs__msg__MovableTarget__DETECTION_STATUS_NEW_TARGET = 1
};

/// Constant 'DETECTION_STATUS_EXISTING_TARGET'.
enum
{
  vrxperience_msgs__msg__MovableTarget__DETECTION_STATUS_EXISTING_TARGET = 2
};

/// Constant 'HIDDEN'.
static const float vrxperience_msgs__msg__MovableTarget__HIDDEN = 0.0f;

/// Constant 'VISIBLE'.
static const float vrxperience_msgs__msg__MovableTarget__VISIBLE = 1.0f;

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'absolute_speed'
// Member 'absolute_angular_speed'
// Member 'relative_speed'
// Member 'relative_angular_speed'
// Member 'absolute_accel'
// Member 'relative_accel'
#include "geometry_msgs/msg/detail/vector3__struct.h"

// Struct defined in msg/MovableTarget in the package vrxperience_msgs.
typedef struct vrxperience_msgs__msg__MovableTarget
{
  std_msgs__msg__Header header;
  int16_t id;
  int16_t scaner_id;
  int16_t detection_status;
  int16_t type;
  int16_t beam_index;
  double existence_time;
  int16_t anchor_point;
  geometry_msgs__msg__Pose pose;
  float distance_to_collision;
  float azimuth_in_sensor;
  float elevation_in_sensor;
  float azimuth_in_vehicle;
  float elevation_in_vehicle;
  geometry_msgs__msg__Vector3 absolute_speed;
  geometry_msgs__msg__Vector3 absolute_angular_speed;
  geometry_msgs__msg__Vector3 relative_speed;
  geometry_msgs__msg__Vector3 relative_angular_speed;
  geometry_msgs__msg__Vector3 absolute_accel;
  geometry_msgs__msg__Vector3 relative_accel;
  float length;
  float width;
  float height;
  float visibility;
} vrxperience_msgs__msg__MovableTarget;

// Struct for a sequence of vrxperience_msgs__msg__MovableTarget.
typedef struct vrxperience_msgs__msg__MovableTarget__Sequence
{
  vrxperience_msgs__msg__MovableTarget * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} vrxperience_msgs__msg__MovableTarget__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__STRUCT_H_
