// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from vrxperience_msgs:msg/MovableTargets.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "vrxperience_msgs/msg/detail/movable_targets__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace vrxperience_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void MovableTargets_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) vrxperience_msgs::msg::MovableTargets(_init);
}

void MovableTargets_fini_function(void * message_memory)
{
  auto typed_message = static_cast<vrxperience_msgs::msg::MovableTargets *>(message_memory);
  typed_message->~MovableTargets();
}

size_t size_function__MovableTargets__targets(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<vrxperience_msgs::msg::MovableTarget> *>(untyped_member);
  return member->size();
}

const void * get_const_function__MovableTargets__targets(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<vrxperience_msgs::msg::MovableTarget> *>(untyped_member);
  return &member[index];
}

void * get_function__MovableTargets__targets(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<vrxperience_msgs::msg::MovableTarget> *>(untyped_member);
  return &member[index];
}

void resize_function__MovableTargets__targets(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<vrxperience_msgs::msg::MovableTarget> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember MovableTargets_message_member_array[5] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(vrxperience_msgs::msg::MovableTargets, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "global_id",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT32,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(vrxperience_msgs::msg::MovableTargets, global_id),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "ego_vehicle_id",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT16,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(vrxperience_msgs::msg::MovableTargets, ego_vehicle_id),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "nearest_target",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT16,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(vrxperience_msgs::msg::MovableTargets, nearest_target),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "targets",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<vrxperience_msgs::msg::MovableTarget>(),  // members of sub message
    true,  // is array
    30,  // array size
    true,  // is upper bound
    offsetof(vrxperience_msgs::msg::MovableTargets, targets),  // bytes offset in struct
    nullptr,  // default value
    size_function__MovableTargets__targets,  // size() function pointer
    get_const_function__MovableTargets__targets,  // get_const(index) function pointer
    get_function__MovableTargets__targets,  // get(index) function pointer
    resize_function__MovableTargets__targets  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers MovableTargets_message_members = {
  "vrxperience_msgs::msg",  // message namespace
  "MovableTargets",  // message name
  5,  // number of fields
  sizeof(vrxperience_msgs::msg::MovableTargets),
  MovableTargets_message_member_array,  // message members
  MovableTargets_init_function,  // function to initialize message memory (memory has to be allocated)
  MovableTargets_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t MovableTargets_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &MovableTargets_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace vrxperience_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<vrxperience_msgs::msg::MovableTargets>()
{
  return &::vrxperience_msgs::msg::rosidl_typesupport_introspection_cpp::MovableTargets_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, vrxperience_msgs, msg, MovableTargets)() {
  return &::vrxperience_msgs::msg::rosidl_typesupport_introspection_cpp::MovableTargets_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
