// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from vrxperience_msgs:msg/VehicleOutput.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__BUILDER_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__BUILDER_HPP_

#include "vrxperience_msgs/msg/detail/vehicle_output__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace vrxperience_msgs
{

namespace msg
{

namespace builder
{

class Init_VehicleOutput_custom_output
{
public:
  explicit Init_VehicleOutput_custom_output(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  ::vrxperience_msgs::msg::VehicleOutput custom_output(::vrxperience_msgs::msg::VehicleOutput::_custom_output_type arg)
  {
    msg_.custom_output = std::move(arg);
    return std::move(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_water_height
{
public:
  explicit Init_VehicleOutput_water_height(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_custom_output water_height(::vrxperience_msgs::msg::VehicleOutput::_water_height_type arg)
  {
    msg_.water_height = std::move(arg);
    return Init_VehicleOutput_custom_output(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_ground_type
{
public:
  explicit Init_VehicleOutput_ground_type(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_water_height ground_type(::vrxperience_msgs::msg::VehicleOutput::_ground_type_type arg)
  {
    msg_.ground_type = std::move(arg);
    return Init_VehicleOutput_water_height(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_roughness_length_stddev
{
public:
  explicit Init_VehicleOutput_roughness_length_stddev(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_ground_type roughness_length_stddev(::vrxperience_msgs::msg::VehicleOutput::_roughness_length_stddev_type arg)
  {
    msg_.roughness_length_stddev = std::move(arg);
    return Init_VehicleOutput_ground_type(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_roughness_height_stddev
{
public:
  explicit Init_VehicleOutput_roughness_height_stddev(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_roughness_length_stddev roughness_height_stddev(::vrxperience_msgs::msg::VehicleOutput::_roughness_height_stddev_type arg)
  {
    msg_.roughness_height_stddev = std::move(arg);
    return Init_VehicleOutput_roughness_length_stddev(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_roughness_length
{
public:
  explicit Init_VehicleOutput_roughness_length(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_roughness_height_stddev roughness_length(::vrxperience_msgs::msg::VehicleOutput::_roughness_length_type arg)
  {
    msg_.roughness_length = std::move(arg);
    return Init_VehicleOutput_roughness_height_stddev(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_roughness_height
{
public:
  explicit Init_VehicleOutput_roughness_height(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_roughness_length roughness_height(::vrxperience_msgs::msg::VehicleOutput::_roughness_height_type arg)
  {
    msg_.roughness_height = std::move(arg);
    return Init_VehicleOutput_roughness_length(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_lane_type
{
public:
  explicit Init_VehicleOutput_lane_type(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_roughness_height lane_type(::vrxperience_msgs::msg::VehicleOutput::_lane_type_type arg)
  {
    msg_.lane_type = std::move(arg);
    return Init_VehicleOutput_roughness_height(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_tire_force
{
public:
  explicit Init_VehicleOutput_tire_force(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_lane_type tire_force(::vrxperience_msgs::msg::VehicleOutput::_tire_force_type arg)
  {
    msg_.tire_force = std::move(arg);
    return Init_VehicleOutput_lane_type(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_slip_angle
{
public:
  explicit Init_VehicleOutput_slip_angle(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_tire_force slip_angle(::vrxperience_msgs::msg::VehicleOutput::_slip_angle_type arg)
  {
    msg_.slip_angle = std::move(arg);
    return Init_VehicleOutput_tire_force(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_lsr
{
public:
  explicit Init_VehicleOutput_lsr(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_slip_angle lsr(::vrxperience_msgs::msg::VehicleOutput::_lsr_type arg)
  {
    msg_.lsr = std::move(arg);
    return Init_VehicleOutput_slip_angle(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_ground_index
{
public:
  explicit Init_VehicleOutput_ground_index(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_lsr ground_index(::vrxperience_msgs::msg::VehicleOutput::_ground_index_type arg)
  {
    msg_.ground_index = std::move(arg);
    return Init_VehicleOutput_lsr(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_grip
{
public:
  explicit Init_VehicleOutput_grip(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_ground_index grip(::vrxperience_msgs::msg::VehicleOutput::_grip_type arg)
  {
    msg_.grip = std::move(arg);
    return Init_VehicleOutput_ground_index(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_ground_normals
{
public:
  explicit Init_VehicleOutput_ground_normals(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_grip ground_normals(::vrxperience_msgs::msg::VehicleOutput::_ground_normals_type arg)
  {
    msg_.ground_normals = std::move(arg);
    return Init_VehicleOutput_grip(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_contact_points
{
public:
  explicit Init_VehicleOutput_contact_points(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_ground_normals contact_points(::vrxperience_msgs::msg::VehicleOutput::_contact_points_type arg)
  {
    msg_.contact_points = std::move(arg);
    return Init_VehicleOutput_ground_normals(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_is_in_contact
{
public:
  explicit Init_VehicleOutput_is_in_contact(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_contact_points is_in_contact(::vrxperience_msgs::msg::VehicleOutput::_is_in_contact_type arg)
  {
    msg_.is_in_contact = std::move(arg);
    return Init_VehicleOutput_contact_points(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_abs_is_active
{
public:
  explicit Init_VehicleOutput_abs_is_active(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_is_in_contact abs_is_active(::vrxperience_msgs::msg::VehicleOutput::_abs_is_active_type arg)
  {
    msg_.abs_is_active = std::move(arg);
    return Init_VehicleOutput_is_in_contact(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_brake_temperature
{
public:
  explicit Init_VehicleOutput_brake_temperature(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_abs_is_active brake_temperature(::vrxperience_msgs::msg::VehicleOutput::_brake_temperature_type arg)
  {
    msg_.brake_temperature = std::move(arg);
    return Init_VehicleOutput_abs_is_active(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_wheel_rotation_speed
{
public:
  explicit Init_VehicleOutput_wheel_rotation_speed(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_brake_temperature wheel_rotation_speed(::vrxperience_msgs::msg::VehicleOutput::_wheel_rotation_speed_type arg)
  {
    msg_.wheel_rotation_speed = std::move(arg);
    return Init_VehicleOutput_brake_temperature(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_wheel_rotation
{
public:
  explicit Init_VehicleOutput_wheel_rotation(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_wheel_rotation_speed wheel_rotation(::vrxperience_msgs::msg::VehicleOutput::_wheel_rotation_type arg)
  {
    msg_.wheel_rotation = std::move(arg);
    return Init_VehicleOutput_wheel_rotation_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_hub_orientation
{
public:
  explicit Init_VehicleOutput_hub_orientation(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_wheel_rotation hub_orientation(::vrxperience_msgs::msg::VehicleOutput::_hub_orientation_type arg)
  {
    msg_.hub_orientation = std::move(arg);
    return Init_VehicleOutput_wheel_rotation(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_hub_position
{
public:
  explicit Init_VehicleOutput_hub_position(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_hub_orientation hub_position(::vrxperience_msgs::msg::VehicleOutput::_hub_position_type arg)
  {
    msg_.hub_position = std::move(arg);
    return Init_VehicleOutput_hub_orientation(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_steering_wheel_torque
{
public:
  explicit Init_VehicleOutput_steering_wheel_torque(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_hub_position steering_wheel_torque(::vrxperience_msgs::msg::VehicleOutput::_steering_wheel_torque_type arg)
  {
    msg_.steering_wheel_torque = std::move(arg);
    return Init_VehicleOutput_hub_position(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_steering_wheel_accel
{
public:
  explicit Init_VehicleOutput_steering_wheel_accel(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_steering_wheel_torque steering_wheel_accel(::vrxperience_msgs::msg::VehicleOutput::_steering_wheel_accel_type arg)
  {
    msg_.steering_wheel_accel = std::move(arg);
    return Init_VehicleOutput_steering_wheel_torque(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_steering_wheel_speed
{
public:
  explicit Init_VehicleOutput_steering_wheel_speed(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_steering_wheel_accel steering_wheel_speed(::vrxperience_msgs::msg::VehicleOutput::_steering_wheel_speed_type arg)
  {
    msg_.steering_wheel_speed = std::move(arg);
    return Init_VehicleOutput_steering_wheel_accel(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_steering_wheel_angle
{
public:
  explicit Init_VehicleOutput_steering_wheel_angle(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_steering_wheel_speed steering_wheel_angle(::vrxperience_msgs::msg::VehicleOutput::_steering_wheel_angle_type arg)
  {
    msg_.steering_wheel_angle = std::move(arg);
    return Init_VehicleOutput_steering_wheel_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_plow_mode
{
public:
  explicit Init_VehicleOutput_plow_mode(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_steering_wheel_angle plow_mode(::vrxperience_msgs::msg::VehicleOutput::_plow_mode_type arg)
  {
    msg_.plow_mode = std::move(arg);
    return Init_VehicleOutput_steering_wheel_angle(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_force_lockup
{
public:
  explicit Init_VehicleOutput_force_lockup(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_plow_mode force_lockup(::vrxperience_msgs::msg::VehicleOutput::_force_lockup_type arg)
  {
    msg_.force_lockup = std::move(arg);
    return Init_VehicleOutput_plow_mode(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_lock_diff_mode
{
public:
  explicit Init_VehicleOutput_lock_diff_mode(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_force_lockup lock_diff_mode(::vrxperience_msgs::msg::VehicleOutput::_lock_diff_mode_type arg)
  {
    msg_.lock_diff_mode = std::move(arg);
    return Init_VehicleOutput_force_lockup(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_transfer_choice
{
public:
  explicit Init_VehicleOutput_transfer_choice(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_lock_diff_mode transfer_choice(::vrxperience_msgs::msg::VehicleOutput::_transfer_choice_type arg)
  {
    msg_.transfer_choice = std::move(arg);
    return Init_VehicleOutput_lock_diff_mode(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_trailer_brake
{
public:
  explicit Init_VehicleOutput_trailer_brake(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_transfer_choice trailer_brake(::vrxperience_msgs::msg::VehicleOutput::_trailer_brake_type arg)
  {
    msg_.trailer_brake = std::move(arg);
    return Init_VehicleOutput_transfer_choice(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_brake_retarder_notch
{
public:
  explicit Init_VehicleOutput_brake_retarder_notch(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_trailer_brake brake_retarder_notch(::vrxperience_msgs::msg::VehicleOutput::_brake_retarder_notch_type arg)
  {
    msg_.brake_retarder_notch = std::move(arg);
    return Init_VehicleOutput_trailer_brake(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_is_engine_retarder
{
public:
  explicit Init_VehicleOutput_is_engine_retarder(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_brake_retarder_notch is_engine_retarder(::vrxperience_msgs::msg::VehicleOutput::_is_engine_retarder_type arg)
  {
    msg_.is_engine_retarder = std::move(arg);
    return Init_VehicleOutput_brake_retarder_notch(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_effective_ignition_key_position
{
public:
  explicit Init_VehicleOutput_effective_ignition_key_position(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_is_engine_retarder effective_ignition_key_position(::vrxperience_msgs::msg::VehicleOutput::_effective_ignition_key_position_type arg)
  {
    msg_.effective_ignition_key_position = std::move(arg);
    return Init_VehicleOutput_is_engine_retarder(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_gear_box_mode
{
public:
  explicit Init_VehicleOutput_gear_box_mode(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_effective_ignition_key_position gear_box_mode(::vrxperience_msgs::msg::VehicleOutput::_gear_box_mode_type arg)
  {
    msg_.gear_box_mode = std::move(arg);
    return Init_VehicleOutput_effective_ignition_key_position(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_clutch_pedal
{
public:
  explicit Init_VehicleOutput_clutch_pedal(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_gear_box_mode clutch_pedal(::vrxperience_msgs::msg::VehicleOutput::_clutch_pedal_type arg)
  {
    msg_.clutch_pedal = std::move(arg);
    return Init_VehicleOutput_gear_box_mode(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_hand_brake
{
public:
  explicit Init_VehicleOutput_hand_brake(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_clutch_pedal hand_brake(::vrxperience_msgs::msg::VehicleOutput::_hand_brake_type arg)
  {
    msg_.hand_brake = std::move(arg);
    return Init_VehicleOutput_clutch_pedal(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_brake_pedal
{
public:
  explicit Init_VehicleOutput_brake_pedal(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_hand_brake brake_pedal(::vrxperience_msgs::msg::VehicleOutput::_brake_pedal_type arg)
  {
    msg_.brake_pedal = std::move(arg);
    return Init_VehicleOutput_hand_brake(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_gas_pedal
{
public:
  explicit Init_VehicleOutput_gas_pedal(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_brake_pedal gas_pedal(::vrxperience_msgs::msg::VehicleOutput::_gas_pedal_type arg)
  {
    msg_.gas_pedal = std::move(arg);
    return Init_VehicleOutput_brake_pedal(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_gear_engaged
{
public:
  explicit Init_VehicleOutput_gear_engaged(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_gas_pedal gear_engaged(::vrxperience_msgs::msg::VehicleOutput::_gear_engaged_type arg)
  {
    msg_.gear_engaged = std::move(arg);
    return Init_VehicleOutput_gas_pedal(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_engine_speed
{
public:
  explicit Init_VehicleOutput_engine_speed(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_gear_engaged engine_speed(::vrxperience_msgs::msg::VehicleOutput::_engine_speed_type arg)
  {
    msg_.engine_speed = std::move(arg);
    return Init_VehicleOutput_gear_engaged(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_pollution
{
public:
  explicit Init_VehicleOutput_pollution(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_engine_speed pollution(::vrxperience_msgs::msg::VehicleOutput::_pollution_type arg)
  {
    msg_.pollution = std::move(arg);
    return Init_VehicleOutput_engine_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_consumption
{
public:
  explicit Init_VehicleOutput_consumption(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_pollution consumption(::vrxperience_msgs::msg::VehicleOutput::_consumption_type arg)
  {
    msg_.consumption = std::move(arg);
    return Init_VehicleOutput_pollution(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_engine_state
{
public:
  explicit Init_VehicleOutput_engine_state(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_consumption engine_state(::vrxperience_msgs::msg::VehicleOutput::_engine_state_type arg)
  {
    msg_.engine_state = std::move(arg);
    return Init_VehicleOutput_consumption(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_auxilary_lights
{
public:
  explicit Init_VehicleOutput_auxilary_lights(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_engine_state auxilary_lights(::vrxperience_msgs::msg::VehicleOutput::_auxilary_lights_type arg)
  {
    msg_.auxilary_lights = std::move(arg);
    return Init_VehicleOutput_engine_state(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_sirens
{
public:
  explicit Init_VehicleOutput_sirens(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_auxilary_lights sirens(::vrxperience_msgs::msg::VehicleOutput::_sirens_type arg)
  {
    msg_.sirens = std::move(arg);
    return Init_VehicleOutput_auxilary_lights(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_lights
{
public:
  explicit Init_VehicleOutput_lights(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_sirens lights(::vrxperience_msgs::msg::VehicleOutput::_lights_type arg)
  {
    msg_.lights = std::move(arg);
    return Init_VehicleOutput_sirens(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_cdg_orientation
{
public:
  explicit Init_VehicleOutput_cdg_orientation(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_lights cdg_orientation(::vrxperience_msgs::msg::VehicleOutput::_cdg_orientation_type arg)
  {
    msg_.cdg_orientation = std::move(arg);
    return Init_VehicleOutput_lights(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_cdg_position
{
public:
  explicit Init_VehicleOutput_cdg_position(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_cdg_orientation cdg_position(::vrxperience_msgs::msg::VehicleOutput::_cdg_position_type arg)
  {
    msg_.cdg_position = std::move(arg);
    return Init_VehicleOutput_cdg_orientation(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_cdg_angular_accel
{
public:
  explicit Init_VehicleOutput_cdg_angular_accel(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_cdg_position cdg_angular_accel(::vrxperience_msgs::msg::VehicleOutput::_cdg_angular_accel_type arg)
  {
    msg_.cdg_angular_accel = std::move(arg);
    return Init_VehicleOutput_cdg_position(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_cdg_accel
{
public:
  explicit Init_VehicleOutput_cdg_accel(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_cdg_angular_accel cdg_accel(::vrxperience_msgs::msg::VehicleOutput::_cdg_accel_type arg)
  {
    msg_.cdg_accel = std::move(arg);
    return Init_VehicleOutput_cdg_angular_accel(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_cdg_angular_speed
{
public:
  explicit Init_VehicleOutput_cdg_angular_speed(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_cdg_accel cdg_angular_speed(::vrxperience_msgs::msg::VehicleOutput::_cdg_angular_speed_type arg)
  {
    msg_.cdg_angular_speed = std::move(arg);
    return Init_VehicleOutput_cdg_accel(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_cdg_speed
{
public:
  explicit Init_VehicleOutput_cdg_speed(::vrxperience_msgs::msg::VehicleOutput & msg)
  : msg_(msg)
  {}
  Init_VehicleOutput_cdg_angular_speed cdg_speed(::vrxperience_msgs::msg::VehicleOutput::_cdg_speed_type arg)
  {
    msg_.cdg_speed = std::move(arg);
    return Init_VehicleOutput_cdg_angular_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

class Init_VehicleOutput_header
{
public:
  Init_VehicleOutput_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_VehicleOutput_cdg_speed header(::vrxperience_msgs::msg::VehicleOutput::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_VehicleOutput_cdg_speed(msg_);
  }

private:
  ::vrxperience_msgs::msg::VehicleOutput msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::vrxperience_msgs::msg::VehicleOutput>()
{
  return vrxperience_msgs::msg::builder::Init_VehicleOutput_header();
}

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__BUILDER_HPP_
