// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/VehicleOutput.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/vehicle_output__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `cdg_speed`
// Member `cdg_angular_speed`
// Member `cdg_accel`
// Member `cdg_angular_accel`
// Member `cdg_position`
// Member `cdg_orientation`
// Member `hub_orientation`
// Member `ground_normals`
// Member `tire_force`
#include "geometry_msgs/msg/detail/vector3__functions.h"
// Member `hub_position`
// Member `contact_points`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
vrxperience_msgs__msg__VehicleOutput__init(vrxperience_msgs__msg__VehicleOutput * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_speed)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_angular_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_angular_speed)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_accel
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_accel)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_angular_accel
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_angular_accel)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_position
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_position)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_orientation
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_orientation)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // lights
  // sirens
  // auxilary_lights
  // engine_state
  // consumption
  // pollution
  // engine_speed
  // gear_engaged
  // gas_pedal
  // brake_pedal
  // hand_brake
  // clutch_pedal
  // gear_box_mode
  // effective_ignition_key_position
  // is_engine_retarder
  // brake_retarder_notch
  // trailer_brake
  // transfer_choice
  // lock_diff_mode
  // force_lockup
  // plow_mode
  // steering_wheel_angle
  // steering_wheel_speed
  // steering_wheel_accel
  // steering_wheel_torque
  // hub_position
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Point__init(&msg->hub_position[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // hub_orientation
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__init(&msg->hub_orientation[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // wheel_rotation
  // wheel_rotation_speed
  // brake_temperature
  // abs_is_active
  // is_in_contact
  // contact_points
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Point__init(&msg->contact_points[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // ground_normals
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__init(&msg->ground_normals[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // grip
  // ground_index
  // lsr
  // slip_angle
  // tire_force
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__init(&msg->tire_force[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // lane_type
  // roughness_height
  // roughness_length
  // roughness_height_stddev
  // roughness_length_stddev
  // ground_type
  // water_height
  // custom_output
  return true;
}

void
vrxperience_msgs__msg__VehicleOutput__fini(vrxperience_msgs__msg__VehicleOutput * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // cdg_speed
  geometry_msgs__msg__Vector3__fini(&msg->cdg_speed);
  // cdg_angular_speed
  geometry_msgs__msg__Vector3__fini(&msg->cdg_angular_speed);
  // cdg_accel
  geometry_msgs__msg__Vector3__fini(&msg->cdg_accel);
  // cdg_angular_accel
  geometry_msgs__msg__Vector3__fini(&msg->cdg_angular_accel);
  // cdg_position
  geometry_msgs__msg__Vector3__fini(&msg->cdg_position);
  // cdg_orientation
  geometry_msgs__msg__Vector3__fini(&msg->cdg_orientation);
  // lights
  // sirens
  // auxilary_lights
  // engine_state
  // consumption
  // pollution
  // engine_speed
  // gear_engaged
  // gas_pedal
  // brake_pedal
  // hand_brake
  // clutch_pedal
  // gear_box_mode
  // effective_ignition_key_position
  // is_engine_retarder
  // brake_retarder_notch
  // trailer_brake
  // transfer_choice
  // lock_diff_mode
  // force_lockup
  // plow_mode
  // steering_wheel_angle
  // steering_wheel_speed
  // steering_wheel_accel
  // steering_wheel_torque
  // hub_position
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Point__fini(&msg->hub_position[i]);
  }
  // hub_orientation
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Vector3__fini(&msg->hub_orientation[i]);
  }
  // wheel_rotation
  // wheel_rotation_speed
  // brake_temperature
  // abs_is_active
  // is_in_contact
  // contact_points
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Point__fini(&msg->contact_points[i]);
  }
  // ground_normals
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Vector3__fini(&msg->ground_normals[i]);
  }
  // grip
  // ground_index
  // lsr
  // slip_angle
  // tire_force
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Vector3__fini(&msg->tire_force[i]);
  }
  // lane_type
  // roughness_height
  // roughness_length
  // roughness_height_stddev
  // roughness_length_stddev
  // ground_type
  // water_height
  // custom_output
}

vrxperience_msgs__msg__VehicleOutput *
vrxperience_msgs__msg__VehicleOutput__create()
{
  vrxperience_msgs__msg__VehicleOutput * msg = (vrxperience_msgs__msg__VehicleOutput *)malloc(sizeof(vrxperience_msgs__msg__VehicleOutput));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__VehicleOutput));
  bool success = vrxperience_msgs__msg__VehicleOutput__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__VehicleOutput__destroy(vrxperience_msgs__msg__VehicleOutput * msg)
{
  if (msg) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
  }
  free(msg);
}


bool
vrxperience_msgs__msg__VehicleOutput__Sequence__init(vrxperience_msgs__msg__VehicleOutput__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vrxperience_msgs__msg__VehicleOutput * data = NULL;
  if (size) {
    data = (vrxperience_msgs__msg__VehicleOutput *)calloc(size, sizeof(vrxperience_msgs__msg__VehicleOutput));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__VehicleOutput__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__VehicleOutput__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__VehicleOutput__Sequence__fini(vrxperience_msgs__msg__VehicleOutput__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__VehicleOutput__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__VehicleOutput__Sequence *
vrxperience_msgs__msg__VehicleOutput__Sequence__create(size_t size)
{
  vrxperience_msgs__msg__VehicleOutput__Sequence * array = (vrxperience_msgs__msg__VehicleOutput__Sequence *)malloc(sizeof(vrxperience_msgs__msg__VehicleOutput__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__VehicleOutput__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__VehicleOutput__Sequence__destroy(vrxperience_msgs__msg__VehicleOutput__Sequence * array)
{
  if (array) {
    vrxperience_msgs__msg__VehicleOutput__Sequence__fini(array);
  }
  free(array);
}
