// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/LaserMeterPoint.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/laser_meter_point__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `intersection_point`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
vrxperience_msgs__msg__LaserMeterPoint__init(vrxperience_msgs__msg__LaserMeterPoint * msg)
{
  if (!msg) {
    return false;
  }
  // hit
  // h_angle
  // v_angle
  // intersection_point
  if (!geometry_msgs__msg__Point__init(&msg->intersection_point)) {
    vrxperience_msgs__msg__LaserMeterPoint__fini(msg);
    return false;
  }
  // distance
  return true;
}

void
vrxperience_msgs__msg__LaserMeterPoint__fini(vrxperience_msgs__msg__LaserMeterPoint * msg)
{
  if (!msg) {
    return;
  }
  // hit
  // h_angle
  // v_angle
  // intersection_point
  geometry_msgs__msg__Point__fini(&msg->intersection_point);
  // distance
}

vrxperience_msgs__msg__LaserMeterPoint *
vrxperience_msgs__msg__LaserMeterPoint__create()
{
  vrxperience_msgs__msg__LaserMeterPoint * msg = (vrxperience_msgs__msg__LaserMeterPoint *)malloc(sizeof(vrxperience_msgs__msg__LaserMeterPoint));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__LaserMeterPoint));
  bool success = vrxperience_msgs__msg__LaserMeterPoint__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__LaserMeterPoint__destroy(vrxperience_msgs__msg__LaserMeterPoint * msg)
{
  if (msg) {
    vrxperience_msgs__msg__LaserMeterPoint__fini(msg);
  }
  free(msg);
}


bool
vrxperience_msgs__msg__LaserMeterPoint__Sequence__init(vrxperience_msgs__msg__LaserMeterPoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vrxperience_msgs__msg__LaserMeterPoint * data = NULL;
  if (size) {
    data = (vrxperience_msgs__msg__LaserMeterPoint *)calloc(size, sizeof(vrxperience_msgs__msg__LaserMeterPoint));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__LaserMeterPoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__LaserMeterPoint__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__LaserMeterPoint__Sequence__fini(vrxperience_msgs__msg__LaserMeterPoint__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__LaserMeterPoint__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__LaserMeterPoint__Sequence *
vrxperience_msgs__msg__LaserMeterPoint__Sequence__create(size_t size)
{
  vrxperience_msgs__msg__LaserMeterPoint__Sequence * array = (vrxperience_msgs__msg__LaserMeterPoint__Sequence *)malloc(sizeof(vrxperience_msgs__msg__LaserMeterPoint__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__LaserMeterPoint__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__LaserMeterPoint__Sequence__destroy(vrxperience_msgs__msg__LaserMeterPoint__Sequence * array)
{
  if (array) {
    vrxperience_msgs__msg__LaserMeterPoint__Sequence__fini(array);
  }
  free(array);
}
