// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/MovableTarget.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/movable_target__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `absolute_speed`
// Member `absolute_angular_speed`
// Member `relative_speed`
// Member `relative_angular_speed`
// Member `absolute_accel`
// Member `relative_accel`
#include "geometry_msgs/msg/detail/vector3__functions.h"

bool
vrxperience_msgs__msg__MovableTarget__init(vrxperience_msgs__msg__MovableTarget * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // id
  // scaner_id
  // detection_status
  // type
  // beam_index
  // existence_time
  // anchor_point
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // distance_to_collision
  // azimuth_in_sensor
  // elevation_in_sensor
  // azimuth_in_vehicle
  // elevation_in_vehicle
  // absolute_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->absolute_speed)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // absolute_angular_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->absolute_angular_speed)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // relative_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->relative_speed)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // relative_angular_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->relative_angular_speed)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // absolute_accel
  if (!geometry_msgs__msg__Vector3__init(&msg->absolute_accel)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // relative_accel
  if (!geometry_msgs__msg__Vector3__init(&msg->relative_accel)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // length
  // width
  // height
  // visibility
  return true;
}

void
vrxperience_msgs__msg__MovableTarget__fini(vrxperience_msgs__msg__MovableTarget * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // id
  // scaner_id
  // detection_status
  // type
  // beam_index
  // existence_time
  // anchor_point
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // distance_to_collision
  // azimuth_in_sensor
  // elevation_in_sensor
  // azimuth_in_vehicle
  // elevation_in_vehicle
  // absolute_speed
  geometry_msgs__msg__Vector3__fini(&msg->absolute_speed);
  // absolute_angular_speed
  geometry_msgs__msg__Vector3__fini(&msg->absolute_angular_speed);
  // relative_speed
  geometry_msgs__msg__Vector3__fini(&msg->relative_speed);
  // relative_angular_speed
  geometry_msgs__msg__Vector3__fini(&msg->relative_angular_speed);
  // absolute_accel
  geometry_msgs__msg__Vector3__fini(&msg->absolute_accel);
  // relative_accel
  geometry_msgs__msg__Vector3__fini(&msg->relative_accel);
  // length
  // width
  // height
  // visibility
}

vrxperience_msgs__msg__MovableTarget *
vrxperience_msgs__msg__MovableTarget__create()
{
  vrxperience_msgs__msg__MovableTarget * msg = (vrxperience_msgs__msg__MovableTarget *)malloc(sizeof(vrxperience_msgs__msg__MovableTarget));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__MovableTarget));
  bool success = vrxperience_msgs__msg__MovableTarget__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__MovableTarget__destroy(vrxperience_msgs__msg__MovableTarget * msg)
{
  if (msg) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
  }
  free(msg);
}


bool
vrxperience_msgs__msg__MovableTarget__Sequence__init(vrxperience_msgs__msg__MovableTarget__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vrxperience_msgs__msg__MovableTarget * data = NULL;
  if (size) {
    data = (vrxperience_msgs__msg__MovableTarget *)calloc(size, sizeof(vrxperience_msgs__msg__MovableTarget));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__MovableTarget__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__MovableTarget__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__MovableTarget__Sequence__fini(vrxperience_msgs__msg__MovableTarget__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__MovableTarget__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__MovableTarget__Sequence *
vrxperience_msgs__msg__MovableTarget__Sequence__create(size_t size)
{
  vrxperience_msgs__msg__MovableTarget__Sequence * array = (vrxperience_msgs__msg__MovableTarget__Sequence *)malloc(sizeof(vrxperience_msgs__msg__MovableTarget__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__MovableTarget__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__MovableTarget__Sequence__destroy(vrxperience_msgs__msg__MovableTarget__Sequence * array)
{
  if (array) {
    vrxperience_msgs__msg__MovableTarget__Sequence__fini(array);
  }
  free(array);
}
