// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/MovableTargetBoundingBox.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET_BOUNDING_BOX__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET_BOUNDING_BOX__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'rear_bottom_right'
// Member 'rear_top_right'
// Member 'rear_bottom_left'
// Member 'rear_top_left'
// Member 'front_bottom_right'
// Member 'front_top_right'
// Member 'front_bottom_left'
// Member 'front_top_left'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__MovableTargetBoundingBox __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__MovableTargetBoundingBox __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MovableTargetBoundingBox_
{
  using Type = MovableTargetBoundingBox_<ContainerAllocator>;

  explicit MovableTargetBoundingBox_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    rear_bottom_right(_init),
    rear_top_right(_init),
    rear_bottom_left(_init),
    rear_top_left(_init),
    front_bottom_right(_init),
    front_top_right(_init),
    front_bottom_left(_init),
    front_top_left(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
    }
  }

  explicit MovableTargetBoundingBox_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    rear_bottom_right(_alloc, _init),
    rear_top_right(_alloc, _init),
    rear_bottom_left(_alloc, _init),
    rear_top_left(_alloc, _init),
    front_bottom_right(_alloc, _init),
    front_top_right(_alloc, _init),
    front_bottom_left(_alloc, _init),
    front_top_left(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int16_t;
  _id_type id;
  using _rear_bottom_right_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _rear_bottom_right_type rear_bottom_right;
  using _rear_top_right_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _rear_top_right_type rear_top_right;
  using _rear_bottom_left_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _rear_bottom_left_type rear_bottom_left;
  using _rear_top_left_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _rear_top_left_type rear_top_left;
  using _front_bottom_right_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _front_bottom_right_type front_bottom_right;
  using _front_top_right_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _front_top_right_type front_top_right;
  using _front_bottom_left_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _front_bottom_left_type front_bottom_left;
  using _front_top_left_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _front_top_left_type front_top_left;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int16_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__rear_bottom_right(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->rear_bottom_right = _arg;
    return *this;
  }
  Type & set__rear_top_right(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->rear_top_right = _arg;
    return *this;
  }
  Type & set__rear_bottom_left(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->rear_bottom_left = _arg;
    return *this;
  }
  Type & set__rear_top_left(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->rear_top_left = _arg;
    return *this;
  }
  Type & set__front_bottom_right(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->front_bottom_right = _arg;
    return *this;
  }
  Type & set__front_top_right(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->front_top_right = _arg;
    return *this;
  }
  Type & set__front_bottom_left(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->front_bottom_left = _arg;
    return *this;
  }
  Type & set__front_top_left(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->front_top_left = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__MovableTargetBoundingBox
    std::shared_ptr<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__MovableTargetBoundingBox
    std::shared_ptr<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MovableTargetBoundingBox_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->rear_bottom_right != other.rear_bottom_right) {
      return false;
    }
    if (this->rear_top_right != other.rear_top_right) {
      return false;
    }
    if (this->rear_bottom_left != other.rear_bottom_left) {
      return false;
    }
    if (this->rear_top_left != other.rear_top_left) {
      return false;
    }
    if (this->front_bottom_right != other.front_bottom_right) {
      return false;
    }
    if (this->front_top_right != other.front_top_right) {
      return false;
    }
    if (this->front_bottom_left != other.front_bottom_left) {
      return false;
    }
    if (this->front_top_left != other.front_top_left) {
      return false;
    }
    return true;
  }
  bool operator!=(const MovableTargetBoundingBox_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MovableTargetBoundingBox_

// alias to use template instance with default allocator
using MovableTargetBoundingBox =
  vrxperience_msgs::msg::MovableTargetBoundingBox_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET_BOUNDING_BOX__STRUCT_HPP_
