// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from vrxperience_msgs:msg/VehicleOutput.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__STRUCT_H_
#define VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'E_GROUND_ASPHALT'.
enum
{
  vrxperience_msgs__msg__VehicleOutput__E_GROUND_ASPHALT = 0l
};

/// Constant 'E_GROUND_CONRETE'.
enum
{
  vrxperience_msgs__msg__VehicleOutput__E_GROUND_CONRETE = 1l
};

/// Constant 'E_GROUND_GRASS'.
enum
{
  vrxperience_msgs__msg__VehicleOutput__E_GROUND_GRASS = 2l
};

/// Constant 'E_GROUND_COBBLESTONE'.
enum
{
  vrxperience_msgs__msg__VehicleOutput__E_GROUND_COBBLESTONE = 3l
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'cdg_speed'
// Member 'cdg_angular_speed'
// Member 'cdg_accel'
// Member 'cdg_angular_accel'
// Member 'cdg_position'
// Member 'cdg_orientation'
// Member 'hub_orientation'
// Member 'ground_normals'
// Member 'tire_force'
#include "geometry_msgs/msg/detail/vector3__struct.h"
// Member 'hub_position'
// Member 'contact_points'
#include "geometry_msgs/msg/detail/point__struct.h"

// Struct defined in msg/VehicleOutput in the package vrxperience_msgs.
typedef struct vrxperience_msgs__msg__VehicleOutput
{
  std_msgs__msg__Header header;
  geometry_msgs__msg__Vector3 cdg_speed;
  geometry_msgs__msg__Vector3 cdg_angular_speed;
  geometry_msgs__msg__Vector3 cdg_accel;
  geometry_msgs__msg__Vector3 cdg_angular_accel;
  geometry_msgs__msg__Vector3 cdg_position;
  geometry_msgs__msg__Vector3 cdg_orientation;
  int32_t lights;
  int32_t sirens;
  int32_t auxilary_lights;
  bool engine_state;
  double consumption;
  double pollution;
  double engine_speed;
  int32_t gear_engaged;
  double gas_pedal;
  double brake_pedal;
  double hand_brake;
  double clutch_pedal;
  int32_t gear_box_mode;
  int32_t effective_ignition_key_position;
  bool is_engine_retarder;
  int32_t brake_retarder_notch;
  double trailer_brake;
  int32_t transfer_choice;
  int32_t lock_diff_mode;
  bool force_lockup;
  int32_t plow_mode;
  double steering_wheel_angle;
  double steering_wheel_speed;
  double steering_wheel_accel;
  double steering_wheel_torque;
  geometry_msgs__msg__Point hub_position[4];
  geometry_msgs__msg__Vector3 hub_orientation[4];
  double wheel_rotation[4];
  double wheel_rotation_speed[4];
  double brake_temperature[4];
  bool abs_is_active[4];
  bool is_in_contact[4];
  geometry_msgs__msg__Point contact_points[4];
  geometry_msgs__msg__Vector3 ground_normals[4];
  double grip[4];
  int32_t ground_index[4];
  double lsr[4];
  double slip_angle[4];
  geometry_msgs__msg__Vector3 tire_force[4];
  int32_t lane_type[4];
  double roughness_height[4];
  double roughness_length[4];
  double roughness_height_stddev[4];
  double roughness_length_stddev[4];
  int32_t ground_type[4];
  double water_height[4];
  double custom_output[512];
} vrxperience_msgs__msg__VehicleOutput;

// Struct for a sequence of vrxperience_msgs__msg__VehicleOutput.
typedef struct vrxperience_msgs__msg__VehicleOutput__Sequence
{
  vrxperience_msgs__msg__VehicleOutput * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} vrxperience_msgs__msg__VehicleOutput__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__STRUCT_H_
